Attribute VB_Name = "MClipMain"
' *************************************************************
'  Copyright (C)1995-98, Karl E. Peterson
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

Private frmView() As frmClipViewer
Private m_nForms As Long

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Any) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Const SM_CYCAPTION = 4
Private Const SM_CYFRAME = 33

Public Sub Main()
   '
   ' Create a new form instance, and show it
   '
   ReDim frmView(0 To 0) As frmClipViewer
   Set frmView(0) = New frmClipViewer
   With frmView(0)
      .Move (Screen.Width - .Width) \ 2, (Screen.Height - .Height) \ 2
      .Show
   End With
   m_nForms = 1
End Sub

Public Sub ViewerNew(frm As frmClipViewer)
   Dim offset&
   ReDim Preserve frmView(0 To m_nForms) As frmClipViewer
   
   offset = (GetSystemMetrics(SM_CYFRAME) + _
      GetSystemMetrics(SM_CYCAPTION)) * _
      Screen.TwipsPerPixelY

   Set frmView(m_nForms) = New frmClipViewer
   With frmView(m_nForms)
      .Top = frm.Top + offset
      .Left = frm.Left + offset
      .Show
   End With
   m_nForms = m_nForms + 1
End Sub

Public Sub ViewerCloseAll()
   Dim i As Long
   On Error Resume Next
   For i = (m_nForms - 1) To 0 Step -1
      Unload frmView(i)
      Set frmView(i) = Nothing
   Next i
End Sub


' ****************************************************
'  String manipulation routines (public)
' ****************************************************
Public Function TrimNull(ByVal StrIn As String) As String
   Dim nul As Long
   '
   ' Truncate input string at first null.
   ' If no nulls, perform ordinary Trim.
   '
   nul = InStr(StrIn, vbNullChar)
   Select Case nul
      Case Is > 1
         TrimNull = Left(StrIn, nul - 1)
      Case 1
         TrimNull = ""
      Case 0
         TrimNull = Trim(StrIn)
   End Select
End Function

' ****************************************************
'  Numeric manipulation routines (public)
' ****************************************************
Public Function MakeLong(WordHi As Variant, WordLo As Integer) As Long
   MakeLong = (WordHi * &H10000) + (WordLo And &HFFFF&)
End Function

Public Function WordHi(LongIn&) As Integer
   WordHi = (LongIn And &HFFFF0000) \ &H10000
End Function

Public Function WordLo(LongIn&) As Integer
   If (LongIn And &HFFFF&) > &H7FFF Then
      WordLo = (LongIn And &HFFFF&) - &H10000
   Else
      WordLo = LongIn And &HFFFF&
   End If
End Function

Public Function FmtHex(ByVal InVal As Long, ByVal OutLen As Integer) As String
   '
   ' Left pad with zeros to OutLen
   '
   FmtHex = Right(String(OutLen, "0") & Hex(InVal), OutLen)
End Function

' ****************************************************
'  Palette Functions (Public)
' ****************************************************
Public Function ScreenColors() As Long
   Dim hdc As Long
   Dim nPlanes As Long
   Dim nBitsPixel As Long
   Const BITSPIXEL = 12         '  Number of bits per pixel
   Const Planes = 14            '  Number of planes

   hdc = CreateDC("DISPLAY", "", "", "")
      nPlanes = GetDeviceCaps(hdc, Planes)
      nBitsPixel = GetDeviceCaps(hdc, BITSPIXEL)
      ScreenColors = 2 ^ CLng(nPlanes * nBitsPixel)
   Call DeleteDC(hdc)
End Function


